// coNetFile.cpp : Implementation of CNetFile
#include "stdafx.h"
#include "Netfile.h"
#include "coNetFile.h"

#include "unc.h"
/////////////////////////////////////////////////////////////////////////////
// CNetFile

STDMETHODIMP CNetFile::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_INetFile
	};
	for (int i=0; i < sizeof(arr) / sizeof(arr[0]); i++)
	{
		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}

STDMETHODIMP CNetFile::getOpenFiles(BSTR *xml)
{
   DWORD nEntriesRead = 0;
   DWORD nTotalEntries = 0;
   DWORD dwResumeHandle = 0;
   int i;
   long nStatus;
   FILE_INFO_3 *pBuf = NULL, *pTmpBuf = NULL;

   nStatus = NetFileEnum(NULL,
                         NULL,
						 NULL,
                         3,
                         (LPBYTE *) &pBuf,
                         MAX_PREFERRED_LENGTH,
                         &nEntriesRead,
                         &nTotalEntries,
						 &dwResumeHandle);

   MSXML2::IXMLDOMElementPtr file;

   //
   // Loop through the entries; process errors.
   //
   if ((nStatus == NERR_Success) || (nStatus == ERROR_MORE_DATA))
   {
      if ((pTmpBuf = pBuf) != NULL)
      {
         for (i = 0; (i < nEntriesRead); i++)
         {
            if (pTmpBuf == NULL)
            {
               //fprintf(stderr, "An access violation has occurred\n");
               break;
            }
			
			file = m_content->createElement("file");

			file->setAttribute("id", _variant_t((long) pTmpBuf->fi3_id));
			file->setAttribute("locks", _variant_t((long) pTmpBuf->fi3_num_locks));

			//switch(pTmpBuf->fi3_permissions)
			//{
			//}

			file->setAttribute("user", _bstr_t((wchar_t *) pTmpBuf->fi3_username));
			file->setAttribute("path", _bstr_t((wchar_t *) pTmpBuf->fi3_pathname));

			CString strPath = (char *) _bstr_t((wchar_t *) pTmpBuf->fi3_pathname);
			strPath.MakeLower();

			file->setAttribute("lowerpath", _bstr_t((LPCTSTR) strPath));

//            printf("\tresource id: %d\n", pTmpBuf->fi3_id);
 //           printf("\n\tpermissions: %d\n", pTmpBuf->fi3_permissions);
 //           printf("\tnum locks:   %d\n", pTmpBuf->fi3_num_locks);

//            wprintf(L"\tpath:   %s\n", pTmpBuf->fi3_pathname);
  //          wprintf(L"\tuser:   %s\n", pTmpBuf->fi3_username);

			m_content->documentElement->appendChild(file);
			file = NULL;

            pTmpBuf++;

//			NetFileClose(NULL, pTmpBuf->fi3_id);
         }
      }

	  NetApiBufferFree(pBuf);
   }

	*xml = _bstr_t(m_content->xml).copy();

//   else
//      fprintf(stderr, "A system error has occurred: %d\n", nStatus);

	return S_OK;
}

STDMETHODIMP CNetFile::closeFile(BSTR path)
{
	long nStatus;
	CUNC l_unc;
	CString uncPath = (char *) _bstr_t(path), localPath = "";

	CString msg; 

	l_unc.GetLocalPathFromUNC(uncPath, &localPath);

	if(uncPath == localPath) {
		msg.Format("attempt to close file: %s", uncPath);
	} else {
		msg.Format("attempt to close file: %s (%s)", uncPath, localPath);
	}
	log.write(msg);

	localPath.Replace("\\", "\\\\");
	localPath.MakeLower();

	CString xpath; xpath.Format("file[@lowerpath=\"%s\"]", localPath);

	MSXML2::IXMLDOMNodeListPtr files = m_content->documentElement->
		selectNodes(_bstr_t(xpath));

	MSXML2::IXMLDOMElementPtr file;
	ULONG id;

	if(files->length < 1) {
		log.write("no opened files");
	}

	for(int i = 0; i < files->length; i++)
	{
		file = files->item[i];

		id = atoi((char *) _bstr_t(file->getAttribute("id")));

		nStatus = ::NetFileClose(NULL, id);

		if(nStatus != NERR_Success) {
			switch(nStatus) 
			{
			case ERROR_ACCESS_DENIED:
					log.write("access denied");
				break;
			case ERROR_FILE_NOT_FOUND:
					log.write("file not found");
				break;
			}
		}


		file = NULL;
	}

	if(nStatus == NERR_Success) {
		log.write("ok");
	}

	return S_OK;
}

STDMETHODIMP CNetFile::getServerName(BSTR *pName)
{
	*pName = _bstr_t(m_content->documentElement->
		getAttribute("srvname")).copy();

	return S_OK;
}

void CNetFile::setServerName()
{
   	LPSERVER_INFO_101 pBuf = NULL;
	DWORD dwLevel = 101;
	NET_API_STATUS nStatus;

	nStatus = ::NetServerGetInfo(NULL,
                              dwLevel,
                              (LPBYTE *)&pBuf);

	if (nStatus == NERR_Success)
	{
		_bstr_t srvName((wchar_t *) pBuf->sv101_name);

		m_content->documentElement->setAttribute("srvname", srvName);
	}

	if (pBuf != NULL) ::NetApiBufferFree(pBuf);
}
