// coNetFile.h : Declaration of the CNetFile

#ifndef __NETFILE_H_
#define __NETFILE_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CNetFile
class ATL_NO_VTABLE CNetFile : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CNetFile, &CLSID_NetFile>,
	public ISupportErrorInfo,
	public IDispatchImpl<INetFile, &IID_INetFile, &LIBID_NETFILELib>
{
public:
	CNetFile()
	{
		m_content.CreateInstance(MSXML2::CLSID_DOMDocument30);
		MSXML2::IXMLDOMElementPtr node = m_content->createElement("files");

		m_content->appendChild(node);
		m_content->async = false;

		setServerName();

		log.Init(_Module.m_hInst);
		log.write("===========================================================");
	}	

DECLARE_REGISTRY_RESOURCEID(IDR_NETFILE)
DECLARE_NOT_AGGREGATABLE(CNetFile)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CNetFile)
	COM_INTERFACE_ENTRY(INetFile)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// INetFile
public:
	STDMETHOD(getServerName)(/*[out, retval]*/ BSTR *pName);
	STDMETHOD(closeFile)(/*[in]*/ BSTR path);
	STDMETHOD(getOpenFiles)(/*[out, retval]*/ BSTR *xml);

protected:
	void setServerName();
	MSXML2::IXMLDOMDocumentPtr m_content;

	CLogFile log;
};

#endif //__NETFILE_H_
